/**
 * Generic PID controller
 */

#ifndef PID_H
#define PID_H

#define HISTORY 10
#define DEFAULT_KP 0.85f
#define DEFAULT_KI 0.0001f
#define DEFAULT_KD 1.0f

/**
 * PID controller
 */

typedef struct {
	float setPoint;

	float Kp;
	float Ki;
	float Kd;
  
	float error;
	float errorSum;
	int errorIndex;
	float *errorSeries;
} PID;


/**
 * PID methods
 */

int PIDInit(PID **pidRef);

void PIDSetGains(PID *pid, float Kp, float Ki, float Kd);

float PIDCalc(PID *pid, float measured);

void PIDDestroy(PID *pid);

#endif
